<script setup lang="ts">
import { ref } from 'vue';
import type { BlogPage } from '@/types/blog';
import { TwitterX, Linkedin, Facebook, Hackernews, Threads } from 'slippers-ui/icons';

defineProps<{ post: BlogPage }>();
const route = useRoute();
const currentPath = route.path;
// Data
const formData = ref({
  config: {
    formId: 1077,
    formName: 'blog-subscription',
  },
  formHeader: "Sign up for GitLab's newsletter",
});
</script>

<template>
  <div class="wrapper">
    <div class="content">
      <slot />
    </div>
    <div class="share">
      <div class="sticky-container">
        <SlpTypography variant="body1-bold" tag="p"> Share this article </SlpTypography>
        <div class="social-icon-links">
          <a
            :href="`https://twitter.com/intent/tweet?text=Check%20out%20${post.title.replaceAll(
              ' ',
              '%20',
            )}&url=https://about.gitlab.com${currentPath}`"
            class="social-link twitter-link twitter-share-button"
            target="_blank"
            data-toggle="tooltip"
            title="Share on twitter"
            data-ga-name="twitter"
            data-ga-location="body"
          >
            <SlpIcon :icon="TwitterX" size="sm" />
          </a>
          <a
            :href="`https://www.linkedin.com/shareArticle?mini=true&url=https://about.gitlab.com${currentPath}`"
            class="social-link linkedin-link"
            target="_blank"
            data-toggle="tooltip"
            title="GitLab on LinkedIn"
            data-ga-name="linkedin"
            data-ga-location="body"
          >
            <SlpIcon :icon="Linkedin" size="sm" />
          </a>
          <a
            :href="`https://www.facebook.com/sharer/sharer.php?u=https://about.gitlab.com${currentPath}`"
            class="social-link facebook-link"
            target="_blank"
            data-toggle="tooltip"
            title="GitLab on Facebook"
            data-ga-name="facebook"
            data-ga-location="body"
          >
            <SlpIcon :icon="Facebook" size="sm" />
          </a>
          <a
            :href="`https://news.ycombinator.com/submitlink?u=https://about.gitlab.com${
              currentPath
            }&t=Check%20out%20${post.title.replaceAll(' ', '%20')}`"
            class="social-link linkedin-link"
            target="_blank"
            data-toggle="tooltip"
            title="GitLab on YouTube"
            data-ga-name="hacker news"
            data-ga-location="body"
          >
            <SlpIcon :icon="Hackernews" size="sm" />
          </a>

          <a
            :href="`https://www.threads.net/intent/post?text=https://about.gitlab.com${currentPath}`"
            class="social-link"
            data-toggle="tooltip"
            data-ga-name="threads"
            data-ga-location="body"
          >
            <SlpIcon color="#000" :icon="Threads" size="sm" />
          </a>
        </div>
        <CommonMktoForm v-if="formData" v-bind="formData" class="newsletter-form" />
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.wrapper {
  display: grid;
  grid-template-columns: 70% 30%;
  padding-top: 40px;
  gap: 64px;
  @media (max-width: $breakpoint-lg) {
    grid-template-columns: 1fr;
  }
}
.social-icon-links {
  display: flex;
  gap: 28px;
  padding: 14px 0;
}
.newsletter-form {
  padding: 24px 0;
  :deep(.form_header) {
    color: $color-text-300;
    text-align: left;
    font-size: 20px;
    font-weight: 600;
    line-height: 24px;
    @media (max-width: $breakpoint-lg) {
      text-align: center;
    }
  }
  :deep(.form_container) {
    padding: 24px;
    border: 1px solid rgba(0, 0, 0, 0.08);
  }
  :deep(.required_label) {
    display: none;
  }
  :deep(#LblEmail) {
    font-size: 16px;
    line-height: 20px;
    color: #000;
    font-weight: 400;
    margin-bottom: 8px;
    width: 100%;
  }
  :deep(#LblCountry) {
    font-size: 16px;
    line-height: 20px;
    color: #000;
    font-weight: 400;
    margin-bottom: 8px;
    width: 100%;
  }
  :deep(#Country) {
    @media (max-width: $breakpoint-lg) {
      width: 100% !important;
    }
  }
  :deep(.mktoGutter.mktoHasWidth) {
    display: none;
  }
  :deep(.mktoOffset.mktoHasWidth) {
    display: none;
  }
  :deep(.mktoHtmlText.mktoHasWidth) {
    color: $color-text-200;
    margin-top: 16px;
    font-size: 14px;
    font-weight: 400;
    line-height: 20px;
    a {
      color: $color-text-200;
      text-decoration: underline;
    }
  }

  :deep(.mktoField.mktoEmailField) {
    height: 44px;
  }
  :deep(.mktoFieldWrap.mktoRequiredField) {
    display: flex;
    flex-direction: column;
  }
  :deep(.mktoErrorMsg) {
    color: red !important;
  }
  :deep(.mktoInvalid) {
    border: 1px solid red !important;
  }
  :deep(.mktoButton) {
    width: 174px !important;
  }
}

.sticky-container {
  position: sticky;
  top: 100px;
}
</style>
